var lat = "", lng = "", mapType = "GOOGLE", icon = "../img_product_type/" + "01" + ".png", zoomControl,showMyLocDirec,zoom;
// 创建对象
var img;

function GetQueryString(name) {
    var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)");
    var r = window.location.search.substr(1).match(reg);
    if (r != null)
        return unescape(r[2]);
    return null;
}

var directionsService;
var directionsDisplay;
var map;
var marker;
var markerPhone;
var markerDevice;
var str = "";
var flightPath = [];
var maptype = google.maps.MapTypeId.ROADMAP;
var infowindow;
var image;
var temp = this;
var addr = "";

function HomeControl(controlDiv) {
    controlDiv.style.paddingTop = '6px';
    var controlUI = document.createElement('div');
    controlUI.style.backgroundColor = 'white';
    controlUI.style.border = '1px solid';
    controlUI.style.cursor = 'pointer';
    controlUI.style.textAlign = 'center';
    controlUI.title = 'Set map to London';
    controlDiv.appendChild(controlUI);
    var controlText = document.createElement('div');
    controlText.style.fontFamily = 'Arial,sans-serif';
    controlText.style.fontSize = '12px';
    controlText.style.paddingLeft = '4px';
    controlText.style.paddingRight = '4px';
    controlText.innerHTML = '<b>History<b>'
    controlUI.appendChild(controlText);
}

var styleEl = document.createElement('style');
document.head.appendChild(styleEl);
styleSheet = styleEl.sheet;

//初始化地图
function initialize() {
    // 创建对象
    img = new Image();
    var myLatlng;
    lat = GetQueryString("lat");
    lng = GetQueryString("lng");
    mapType = GetQueryString("mapType");
    icon = GetQueryString("icon");
    if (typeof (lat) == "undefined" || typeof (lng) == "undefined") {
        myLatlng = new google.maps.LatLng(0, 0);
    } else {
        if (typeof (mapType) != "undefined" && mapType == "GPS") {
            var gpsvalue1 = GPS.gcj_encrypt(lat, lng);
            myLatlng = new google.maps.LatLng(gpsvalue1.lat, gpsvalue1.lon);
        } else {
            myLatlng = new google.maps.LatLng(lat, lng);
        }
    }
    var mapOptions;
    zoomControl = GetQueryString("zoomControl");
    zoom = GetQueryString("zoom");
    if (typeof (zoom) == "undefined" || zoom == null || zoom == "") {
        zoom=15;
    }else{
        zoom=parseFloat(zoom);
    }
    if (zoomControl != null && zoomControl == "false") {
        mapOptions = {
            zoom: zoom,
            center: myLatlng,
            mapTypeId: maptype,
            mapTypeControl: false,
            scaleControl: true,
            streetViewControl: false,
            zoomControl: false,
            panControl: false,
            fullscreenControl: false
        };
        var checkimg = document.getElementById("satelliteLabel");
        checkimg.style.visibility = "hidden";
    } else {
        mapOptions = {
            zoom: zoom,
            center: myLatlng,
            mapTypeId: maptype,
            mapTypeControl: false,
            scaleControl: true,
            streetViewControl: false,
            zoomControl: true,
            panControl: false,
            fullscreenControl: false
        };
    }
    temp.control = map = new google.maps.Map(document.getElementById('map-canvas'), mapOptions);
    if (typeof (icon) == "undefined" || icon == null || icon == "") {
        icon = "../img_product_type/" + "im_device_loc" + ".png";
    } else {
        icon = "../img_product_type/" + icon + ".png";
    }
    var img_url = icon;
    //alert(img_url);
    // 改变图片的src
    img.src = img_url;
    img.onload = function () {
        if (img.width > 40) {
            img.width = img.width / 2;
            img.height = img.height / 2;
        }
        //alert("complete,width="+img.width+",height="+img.height);
        var phoneImage = {
            url: img_url,
            scaledSize: new google.maps.Size(img.width, img.height)
        };
        //        marker = addOneMarker(myLatlng, phoneImage);
        //        flightPath.push(marker);
        //        map.setCenter(marker.getPosition());
        infowindow = initInfoWindow();
        bridgeInterface.OnMapLoadedCallback();
        //        marker.setMap(null);
    }

    directionsDisplay = new google.maps.DirectionsRenderer();
    directionsService = new google.maps.DirectionsService();
    //地图瓦片加载完成之后的回调
    isFirstLoad = true;

    //        google.maps.event.addListener(map, 'tilesloaded', function () {
    //            if (isFirstLoad) {
    //				 isFirstLoad = false;
    //				 logo();
    //            }
    //        });
}

function logo() //去除logo和版权
{
    // var a = document.getElementById('map');
    // alert(window.document.body.innerHTML);

    var lst = document.getElementsByTagName("a");
    // alert(lst);
    for (i = 0; i < lst.length; i++) {
        //alert(lst[i].parentElement.parentElement.innerHTML);

        lst[i].parentElement.style.display = "none";
        if (i == 1)
            lst[i].parentElement.parentElement.parentElement.style.display = "none";
        if (i > 1)
        //   alert(lst[i].parentElement.parentElement.parentElement.innerHTML);
            lst[i].parentElement.parentElement.style.display = "none";
        // alert(lst[i].parentElement.className);
    }
    //alert("logo over");
}

function setPhoneLocCenter(latitude, longitude, center, ic, msg, hangxiang, markerLoaded1) {

    var myNewLatlng = new google.maps.LatLng(latitude, longitude);
    var img = new Image();
    var img_url;
    if (typeof (ic) == "undefined" || ic == null || ic == "") {
        img_url = "../img_product_type/" + "01" + ".png";
    } else {
        img_url = ic;
    }
    // 改变图片的src
    img.src = img_url;
    img.onload = function () {
        if (img.width > 40) {
            img.width = img.width / 2;
            img.height = img.height / 2;
        }
        var phoneImage = {
            url: img_url,
            scaledSize: new google.maps.Size(img.width, img.height)
        };
        if (ic.indexOf("geo") != -1 || (ic.indexOf("img_product_type_list") == -1&&ic.indexOf("img_product_cusicon") == -1)) {
            markerPhone = addOneMarkerPhone(myNewLatlng, phoneImage);
        } else {
            if (typeof (markerPhone) == "undefined"||!markerPhone) {
                setTimeout(function () {
                    markerPhone.setContent(msg);
                }, 150);
            }
            markerPhone = addOneMyMarkerPhone(myNewLatlng, phoneImage);
            markerPhone.setRotate(hangxiang);
        }
        if (typeof (markerLoaded1) != "undefined") {
            markerLoaded1(markerPhone);
        }
        var markerTypes = [];
        markerTypes.push(markerPhone);
        arr[ic] = markerTypes;
    }
    if (center) {
        map.panTo(myNewLatlng);
    }
}

function setDeviceLocCenter(latitude, longitude, center, ic, msg, hangxiang, markerLoaded1) {
    var myNewLatlng = new google.maps.LatLng(latitude, longitude);
    var img = new Image();
    var img_url;
    if (typeof (ic) == "undefined" || ic == null || ic == "") {
        img_url = "../img_product_type/" + "01" + ".png";
    } else {
        img_url = ic;
    }
    img.onload = function () {
        if (img.width > 40) {
            img.width = img.width / 2;
            img.height = img.height / 2;
        }
        var phoneImage = {
            url: img_url,
            scaledSize: new google.maps.Size(img.width, img.height)
        };
        if (ic.indexOf("geo") != -1 || (ic.indexOf("img_product_type_list") == -1&&ic.indexOf("img_product_cusicon") == -1)) {
            markerDevice = addOneMarker(myNewLatlng, phoneImage);
        } else {
            if (typeof (markerDevice) == "undefined"||!markerDevice) {
                setTimeout(function () {
                    markerDevice.setContent(msg);
                }, 150);
            }
            markerDevice = addOneMyMarkerDevice(myNewLatlng, phoneImage);
            markerDevice.setRotate(hangxiang);
        }
        if (typeof (markerLoaded1) != "undefined") {
            markerLoaded1(markerDevice);
        }
        var markerTypes = [];
        markerTypes.push(markerDevice);
        arr[ic] = markerTypes;
    }
    // 改变图片的src
    img.src = img_url;
    if (center) {
        map.panTo(myNewLatlng);
    }
}

var oneMarkerUrl="";
function addOneMarker(myNewLatlng, phoneImage) {
    if (typeof (markerDevice) == "undefined"||markerDevice == null) {
        markerDevice = addMarkerRaw(myNewLatlng);
        oneMarkerUrl=phoneImage.url;
    }
    if(oneMarkerUrl!=phoneImage.url){
        markerDevice.setMap(null);
        markerDevice = addMarkerRaw(myNewLatlng);
        oneMarkerUrl=phoneImage.url;
    }
    console.log(oneMarkerUrl);
    markerDevice.setPosition(myNewLatlng);
    markerDevice.setIcon(phoneImage);
    return markerDevice;
}

function addOneMyMarkerDevice(myNewLatlng, phoneImage) {
    if (typeof (markerDevice) == "undefined"||markerDevice == null) {
        markerDevice = addMyMarkerRaw(myNewLatlng);
        oneMarkerUrl=phoneImage.url;
    }
    if(oneMarkerUrl!=phoneImage.url){
        markerDevice.setMap(null);
        markerDevice = addMyMarkerRaw(myNewLatlng);
        oneMarkerUrl=phoneImage.url;
    }
    markerDevice.setPosition(myNewLatlng);
    markerDevice.setIcon(phoneImage);
    return markerDevice;
}

function addOneMarkerPhone(myNewLatlng, phoneImage) {
    if (typeof (markerPhone) == "undefined"||markerPhone == null) {
        markerPhone = addMarkerRaw(myNewLatlng);
    }
    markerPhone.setPosition(myNewLatlng);
    markerPhone.setIcon(phoneImage);
    return markerPhone;
}

function addOneMyMarkerPhone(myNewLatlng, phoneImage) {
    if (typeof (markerPhone) == "undefined"||markerPhone == null) {
        markerPhone = addMyMarkerRaw(myNewLatlng);
    }
    markerPhone.setPosition(myNewLatlng);
    markerPhone.setIcon(phoneImage);
    return markerPhone;
}

function addMarkerRaw(latlng) {
    var markerRaw = new google.maps.Marker({
        map: map
    });
    return markerRaw;
}

function addMyMarkerRaw(latlng) {
    var markerRaw = new MyMarker({
        map: map,
        latlng:latlng
    });
    return markerRaw;
}

var manualClosure = false;
var click_lis;
var windowMarker;
var autoShowPop = false;

function infowindowOpen(map, marker) {
    infowindow.open(map, marker);
    manualClosure = false;
    windowMarker = marker;
    infowindow.setOptions({maxWidth:"61.8%"});
    if (typeof marker.isMsg === "function"&&marker.markerImg!=null) {
        if(marker.markerImg.src.indexOf("img_product_type_list") == -1){
            infowindow.setOptions({pixelOffset: new google.maps.Size(0, -marker.markerImg.height)});
        }else{
            infowindow.setOptions({pixelOffset: new google.maps.Size(0, -marker.markerImg.height / 2)});
        }
    }
//    setTimeout(function (){
//     document.getElementsByClassName("gm-style-iw-a")[0].style.top=-this.img_.height/2 + 'px';
//    }, 100);

}
function onlyInfoPop(marker, msg) {
    // if (typeof marker.isMsg === "function") {
    //     if (marker.msgDiv_ != null && marker.msgDiv_.style.visibility == "visible") {
    //         marker.setContent(msg);
    //     }
    // } else {
    //     if (infowindow == null) {
    //         infowindow = initInfoWindow();
    //     }
    //     infowindow.setContent(msg);
    //     infowindow.setPosition(marker.getPosition());
    //     if (!manualClosure) {
    //         infowindowOpen(map, marker);
    //     }
    // }

    if (infowindow == null) {
        infowindow = initInfoWindow();
    }
    infowindow.setContent(msg);
    infowindow.setPosition(marker.getPosition());
    if (!manualClosure) {
        infowindowOpen(map, marker);
    }

    click_lis = google.maps.event.addListener(marker, 'click', function () {
        // if (typeof marker.isMsg === "function") {
        //     marker.setContent(msg);
        //     manualClosure = false;
        // } else {
        //     infowindow.setContent(msg);
        //     infowindowOpen(map, marker);
        // }
        infowindow.setContent(msg);
        infowindowOpen(map, marker);
        var latlng = marker.getPosition();
        bridgeInterface.LatlngCallback(latlng.lat(), latlng.lng());
    });
    google.maps.event.addListener(infowindow, 'closeclick', function () {
        manualClosure = true;
        autoShowPop = false;
//        infowindow = null;
    });
    //    var width = document.body.clientWidth;
    //    $(".gm-style-iw").style = "max-width: "+ (width * 0.618) +"px !important";

}

function initInfoWindow() {
    var infowindow = MyInfoWindow({
        maxWidth: window.screen.width * 0.618,
        //pixelOffset: new google.maps.Size(0, -100)
    });

    //infowindow.setPixelOffset(-100);
    google.maps.event.addListener(infowindow, 'closeclick', function () {
        manualClosure = true;
        autoShowPop = false;
    });
    return infowindow;
}

function MyInfoWindow() {
    this.infowindow_ = new google.maps.InfoWindow({
        maxWidth: window.screen.width * 0.618,
        //pixelOffset: new google.maps.Size(0, -100)
    });

    return infowindow_;
}

MyInfoWindow.prototype.setPixelOffset = function (yOffset) {
    pixelOffset = new google.maps.Size(0, -yOffset);
}


MyInfoWindow.prototype = new google.maps.InfoWindow();

function getAddress(lat, lng, responseCallback) {
    //  22.9937272551, 113.4239657765
    //innerAddr();
    var latlng = new google.maps.LatLng(lat, lng);
    var geocoder = new google.maps.Geocoder();
    geocoder.geocode({
        'latLng': latlng
    }, function (results, status) {
        if (status == google.maps.GeocoderStatus.OK) {
            if (results[1]) {
                var sAddress = results[1].formatted_address;
                //中文地址
                addr = sAddress;
                var module = {
                    "moduleName": "Addr",
                    "data": [{
                        "addr": addr
                    }]
                };
                responseCallback(module);
            }
        }
    });
}

var circle;
//var radiuvalue = 100;
var isfence, clickPoint;
//设置围栏： type为true时，创建以半径为value大小、以当前地图中心为圆心的圆
//		 type为false时,清除圆
function setFence(type, value, lat, lng) {

    isfence = (type == 1);

    radiuvalue = value;
    if (clickPoint == null) {
        clickPoint = map.getCenter();
    }
    if (isfence) {
        clickPoint = new google.maps.LatLng(lat, lng);
    }
    if (circle == null) {
        circle = new google.maps.Circle({
            map: map,
            center: clickPoint,
            radius: radiuvalue,
            strokeColor: "#FF0000",
            strokeOpacity: 1.0,
            strokeWeight: 1,
            fillColor: "#FF4040",
            //				draggable:true,
            fillOpacity: 0.5
        });
        addListeners();
    } else {
        circle.setRadius(radiuvalue);
        circle.setCenter(clickPoint);
    }

    map.panTo(clickPoint);
    callBackJava();

}

function callBackJava() {
    if (circle != null) {
        //调用android 中的returnCenter方法
        //调用GPS中gcj_decrypt_exact方法：将Google坐标精确转换成GPS坐标
        var latlng = circle.getCenter();
        var gpsVar = GPS.gcj_decrypt_exact(latlng.lat(), latlng.lng());
        bridgeInterface.FenceLatLng(clickPoint.lat(), clickPoint.lng());
        //window.android.returnFenceCenterLatLng(gpsVar['lat'],gpsVar['lon']);
        //window.android.returnCenter(clickPoint.lat(),clickPoint.lng());
    }
}

function returnCenter(lat, lng) {
    //  22.9937272551, 113.4239657765

    var latlng = new google.maps.LatLng(lat, lng);
    var geocoder = new google.maps.Geocoder();
    geocoder.geocode({
        'latLng': latlng
    }, function (results, status) {
        if (status == google.maps.GeocoderStatus.OK) {
            if (results[1]) {
                var sAddress = results[1].formatted_address;
                //中文地址
                window.android.returnCenter(sAddress);
                return sAddress;
            }
        }
    });
}

function addListeners() {
    google.maps.event.addListener(circle, 'click', function (event) {
        clickPoint = event.latLng;
        setFence(0, radiuvalue, clickPoint.lat(), clickPoint.lng());
    });
    google.maps.event.addListener(map, 'click', function (event) {
        clickPoint = event.latLng;
        setFence(0, radiuvalue, clickPoint.lat(), clickPoint.lng());
    });
}

function satellite(flag) {
    if (flag) {
        maptype = google.maps.MapTypeId.HYBRID;
    } else {
        maptype = google.maps.MapTypeId.ROADMAP;
    }
    var amt = GetQueryStringUrl("AMT");
    if (typeof (amt) != "undefined" && amt != null && amt == "Bing") {
        if (flag) {
            maptype = "Bingsatellite";
        } else {
            maptype = amt;
        }

    }
    map.setMapTypeId(maptype);
}

var trafficLayer;

function traffic(flag) {
    if (flag) {
        trafficLayer = new google.maps.TrafficLayer();
        trafficLayer.setMap(map);
    } else {
        if (trafficLayer != null) {
            trafficLayer.setMap(null);
            trafficLayer = null;
        }
    }

}

function panoramioLayer(flag) {
    logo();
}

var lastPoint = null;
var trackPath = [];

function tracklines(lat, lng, center, lineColor) {
    var myNewLatlng = new google.maps.LatLng(lat, lng);
    if (lastPoint != null && (lastPoint.lat() != myNewLatlng.lat() && lastPoint.lng() != myNewLatlng.lng())) {
        var tmplines = [];
        tmplines.push(lastPoint);
        tmplines.push(myNewLatlng);
        //创建线路
        var polylineOptions = {
            path: tmplines,
            //所有的GPS坐标点
            strokeOpacity: 1.0,
            strokeWeight: 3,
            zIndex: 10
        };

        if (typeof (lineColor) == "undefined" || lineColor == null || lineColor == "" || lineColor == "-1") {
            polylineOptions.strokeColor = "#00ff00";
            //线路颜色
        } else if (lineColor == "0") {
            //透明
            polylineOptions.strokeOpacity = 0.0;
        } else {
            polylineOptions.strokeColor = lineColor;
            //线路颜色
        }
        var flight = new google.maps.Polyline(polylineOptions);
        flight.setMap(map);
        trackPath.push(flight);
    }
//     if(marker!=null){
//         marker.setRotate(hangxiang);
//     }
    lastPoint = myNewLatlng;
    if (center) {
        var bounds = map.getBounds();
//            bounds.extend(myNewLatlng);
        if (!bounds.contains(myNewLatlng)) {
            map.panTo(myNewLatlng);
        }
    }
}

function cleanTrackPath() {
    for (var i = 0; i < trackPath.length; i++) {
        trackPath[i].setMap(null);
    }
    lastPoint = null;
    trackPath = [];
}

function scaleZoom(operation) {
    var curZoom = map.getZoom();
    if (operation == "+") {
        curZoom++;
        map.setZoom(curZoom);
    } else if (operation == "-") {
        curZoom--;
        map.setZoom(curZoom);
    } else {
        if (!checkRate(operation)) {
            operation = "10";
        }
        map.setZoom(parseInt(operation));

    }
}

function checkRate(input) {
    var re = /^[0-9]+.?[0-9]*$/;
    //判断字符串是否为数字 //判断正整数 /^[1-9]+[0-9]*]*$/
    if (!re.test(input)) {
        //alert("请输入数字");
        return false;
    }
    return true;
}

function drawLines(latLngs, mapType) {
    //deleteOverlays();
    var tmplines = [];
    var i = latLngs.length;
    //设置地图缩放
    var bounds = new google.maps.LatLngBounds();
    for (i in latLngs) {
        var latlng;
        if (mapType == "GPS") {
            var gpsvalue1 = GPS.gcj_encrypt(latLngs[i].lat, latLngs[i].lng);
            latlng = new google.maps.LatLng(gpsvalue1.lat, gpsvalue1.lon);
        } else {
            latlng = new google.maps.LatLng(latLngs[i].lat, latLngs[i].lng);
        }
        tmplines.push(latlng);
        bounds.extend(latlng);
    }
    var flight = new google.maps.Polyline({
        path: tmplines,
        strokeColor: '#FF0000',
        strokeOpacity: 1.0,
        strokeWeight: 4
    });
    flight.setMap(map);
    flightPath.push(flight);
    map.fitBounds(bounds);
}

var distanceLineBetweenTwoPlacesOverlayOptions = [];

function drawDistanceLineBetweenTwoPlaces(startlat, startlng, endLat, endLng, color, isBounds) {
    //deleteOverlays();
    clearDistanceLineBetweenTwoPlacesOverlayOptions();
    var tmplines = [];
    //设置地图缩放
    var bounds = new google.maps.LatLngBounds();
    var startLatlng = new google.maps.LatLng(startlat, startlng);
    var endLatlng = new google.maps.LatLng(endLat, endLng);
    tmplines.push(startLatlng);
    tmplines.push(endLatlng);
    bounds.extend(startLatlng);
    bounds.extend(endLatlng);
    var flight = new google.maps.Polyline({
        path: tmplines,
        strokeColor: color,
        strokeOpacity: 1.0,
        strokeWeight: 3
    });
    flight.setMap(map);
    distanceLineBetweenTwoPlacesOverlayOptions.push(flight);
    if (isBounds) {
        map.fitBounds(bounds);
    }

}

function clearDistanceLineBetweenTwoPlacesOverlayOptions() {
    for (var i = 0; i < distanceLineBetweenTwoPlacesOverlayOptions.length; i++) {
        distanceLineBetweenTwoPlacesOverlayOptions[i].setMap(null);
    }
    distanceLineBetweenTwoPlacesOverlayOptions = [];
}

function drawSymbolLines(latLngs, mapType) {
    onDestroy();
    var tmplines = [];
    var bounds = new google.maps.LatLngBounds();
    var lineSymbol = {
        path: 'M 0,-1 0,1',
        strokeOpacity: 1,
        scale: 2
    };
    var i = latLngs.length;
    for (i in latLngs) {
        var latlng;
        if (mapType == "GPS") {
            var gpsvalue1 = GPS.gcj_encrypt(latLngs[i].lat, latLngs[i].lng);
            latlng = new google.maps.LatLng(gpsvalue1.lat, gpsvalue1.lon);
        } else {
            latlng = new google.maps.LatLng(latLngs[i].lat, latLngs[i].lng);
        }
        tmplines.push(latlng);
        bounds.extend(latlng);
    }
    var flight = new google.maps.Polyline({
        path: tmplines,
        strokeColor: '#FF0000',
        strokeOpacity: 0,
        zIndex: 0,
        icons: [{
            icon: lineSymbol,
            offset: '0',
            repeat: '20px'
        }],
        strokeWeight: 4
    });
    flight.setMap(map);
    flightPath.push(flight);
    map.fitBounds(bounds);

}

var arr = new Array();

function addMarkerTypes(stays, lbses, wifis, mapType) {
    if (stays != null && stays.length > 0) {
        var markerTypes = addMarkers(stays, "im_parking");
        arr["p"] = markerTypes;
    }
    if (lbses != null && lbses.length > 0) {
        var markerTypes = addMarkers(lbses, "im_lbs");
        arr["lbs"] = markerTypes;
    }
    if (wifis != null && wifis.length > 0) {
        var markerTypes = addMarkers(wifis, "im_wifi");
        arr["wifi"] = markerTypes;
    }
}

function addMoreDeviceMarkers(moreDevices, mapType, fitBounds, selMacId, firstShowPopInfoWindow) {
    if (moreDevices != null && moreDevices.length > 0) {
        var markerTypes = addMoreDeviceMarkersToMap(moreDevices, "im_parking", mapType, fitBounds, selMacId, firstShowPopInfoWindow);
        arr["p"] = markerTypes;
    } else {
        if (typeof (moreDeviceMarkers) != "undefined") {
            for (var key in moreDeviceMarkers) {
                var moreDeviceMarker = moreDeviceMarkers[key];
                if (typeof (moreDeviceMarker) != "undefined") {
                    moreDeviceMarker.setMap(null);
                    moreDeviceMarker = null;
                    //                    moreDeviceMarkers[key]=moreDeviceMarker;
                }
            }
            moreDeviceMarkers = new Array();
        }
    }
}

var moreDeviceMarkers = new Array();
var markerIndex = 1000;

function addMoreDeviceMarkersToMap(objs, ic, mapType, fitBounds, selMacId, firstShowPopInfoWindow) {
    var markerTypes = [];
    if (objs != null) {
        if (typeof (moreDeviceMarkers) != "undefined") {
            for (var key in moreDeviceMarkers) {
                var moreDeviceMarker = moreDeviceMarkers[key];
                if (moreDeviceMarker != null && typeof (moreDeviceMarker) != "undefined") {
                    moreDeviceMarker.setMap(null);
                    moreDeviceMarker = null;
                }
            }
        } else {
            moreDeviceMarkers = new Array();
        }
        var img_url = "./img/" + ic + ".png";
        markerIndex = 1000;
        var bounds = new google.maps.LatLngBounds();
        for (var i in objs) {
            var obj = objs[i];
            var icon = obj.icon;
            var img_url;
            if (typeof (icon) == "undefined" || icon == null || icon == "") {
                img_url = "../img_product_type/" + "01" + ".png";
            } else {
                img_url = icon;
            }
            var img = new Image();
            img.onload = (function (obj, img_url, img) {
                    var lastMoreDeviceMarker = moreDeviceMarkers[obj.macId];
                    if (lastMoreDeviceMarker != null && typeof (lastMoreDeviceMarker) != "undefined") {
                        lastMoreDeviceMarker.setMap(null);
                        lastMoreDeviceMarker = null;
                        moreDeviceMarkers[obj.macId] = lastMoreDeviceMarker;
                    }
                    var myNewLatlng;
                    if (mapType == "GPS") {
                        var gpsvalue1 = GPS.gcj_encrypt(obj.lat, obj.lng);
                        latlng = new google.maps.LatLng(gpsvalue1.lat, gpsvalue1.lon);
                    } else {
                        myNewLatlng = new google.maps.LatLng(obj.lat, obj.lng);
                    }
                    var marker;

                    if (obj.showNameToMap) {
                        var name = obj.deviceName;
                        var rotate = 0;
                        if (!obj.defIcon) {
                            rotate = obj.hangxiang
                        }
                        var marker = new MyMarker({
                            latlng: myNewLatlng,
                            labelText: name,
                            labelClass: "gm-style-marker-label",
                            img: img,
                            rotate: rotate,
                            msg: obj.msg
                        });
                        marker.setIcon(img_url);
                    } else {
                        if (img.width > 40 || img.height > 40) {
                            img.width = img.width / 2.0;
                            img.height = img.height / 2.0;
                        }
                        var phoneImage = {
                            url: img_url,
                            scaledSize: new google.maps.Size(img.width, img.height)
                        };
                        marker = new google.maps.Marker({
                            position: myNewLatlng,
                            icon: phoneImage,
                        });
                    }

                    if (obj.lat != 0 && obj.lng != 0) {
                        bounds.extend(myNewLatlng);
                    }
                    if (obj.isVisible) {
                        marker.setMap(map);
                    }
                    google.maps.event.addListener(marker, 'click', (function (marker, obj) {
                            return function () {
                                // if (typeof marker.isMsg === "function" && marker.msgDiv_ != null) {
                                //     marker.msgDiv_.style.visibility = "visible"
                                // }
                                autoShowPop = true;
                                map.panTo(marker.getPosition());
                                var latlng = marker.getPosition();
                                bridgeInterface.LatlngCallback(latlng.lat(), latlng.lng(), obj.macId);
                            }
                        }
                    )(marker, obj));
                    markerTypes.push(marker);
                    moreDeviceMarkers[obj.macId] = marker;
                }
            )(obj, img_url, img)
            img.src = img_url;
        }
        if (fitBounds) {
            map.fitBounds(bounds);
            var curZoom = map.getZoom();
            if (curZoom > 15) {
                map.setZoom(15);
            }
        }else{
            if (typeof (zoom) == "undefined" || zoom == null || zoom == "") {
                var curZoom = map.getZoom();
                if (curZoom > 15) {
                    map.setZoom(15);
                }
            }else{
                map.setZoom(zoom);
            }
        }

        if (firstShowPopInfoWindow || autoShowPop) {
            manualClosure = false;
        } else {
            manualClosure = true;
        }

        //            if(!firstShowPopInfoWindow&&!autoShowPop){//如果首次不显示气泡，则置为关闭状态
        //                autoShowPop=false;
        //                manualClosure=true;
        //            }
        var moreDeviceMarker = moreDeviceMarkers[selMacId];
        if (moreDeviceMarker != null) {
            var latlng = moreDeviceMarker.getPosition();
//            showSelTheFirstFewDeviceMsg(selMacId);
            bridgeInterface.LatlngCallback(latlng.lat(), latlng.lng(), selMacId);
        }
    }
    return markerTypes;
}



var selMacIdMarker = null;

function showSelTheFirstFewDeviceMsg(macId, msg,isCenter) {
    if (selMacIdMarker != null && selMacIdMarker != macId) {
        var lastMarker = moreDeviceMarkers[selMacIdMarker];
        if (typeof (lastMarker) != "undefined") {
            lastMarker.closeMsg();
            selMacIdMarker = null;
        }
    }
    var moreDeviceMarker = moreDeviceMarkers[macId];
    if (moreDeviceMarker == null || typeof (moreDeviceMarker) == "undefined") {
        return;
    }
    if(isCenter){
        map.panTo(moreDeviceMarker.getPosition());
    }
    moreDeviceMarker.setZIndex(markerIndex++);
    if (typeof (msg) == "undefined") {
        return;
    }
    if (true) {
        if (infowindow != null && typeof (infowindow) != "undefined") {
            if (typeof moreDeviceMarker.isMsg === "function") {
                if (moreDeviceMarker.markerImg!=null&&moreDeviceMarker.markerImg.src.indexOf("img_product_type_list") == -1) {
                    infowindow.setOptions({pixelOffset: new google.maps.Size(0, -moreDeviceMarker.img_.height)});
                } else {
                    infowindow.setOptions({pixelOffset: new google.maps.Size(0, -moreDeviceMarker.img_.height / 2)});
                }
            }
            infowindow.setPosition(moreDeviceMarker.getPosition());
            infowindow.setContent(msg);
            if (!manualClosure || autoShowPop) {
                infowindowOpen(map, moreDeviceMarker);
            }
        }
        return;
    }
    if (typeof moreDeviceMarker.isMsg === "function") {
        moreDeviceMarker.setContent(msg);
        if (selMacIdMarker == null || typeof (selMacIdMarker) == "undefined") {
            moreDeviceMarker.setContent(msg);
        }
        if ((moreDeviceMarker.msgDiv_ != null && moreDeviceMarker.msgDiv_.style.visibility == "visible")) {
            moreDeviceMarker.setContent(msg);
        }
        selMacIdMarker = macId;
    } else {
        if (infowindow != null && typeof (infowindow) != "undefined") {
            infowindow.setPosition(moreDeviceMarker.getPosition());
            infowindow.setContent(msg);
            if (!manualClosure || autoShowPop) {
                infowindowOpen(map, moreDeviceMarker);
            }
        }
    }


}

function removeMarkerTypes(isVisible, key) {
    var markerTypes = arr[key];
    if (typeof (markerTypes) == "undefined") {
        return;
    }
    for (var i = 0; i < markerTypes.length; i++) {
        if (!isVisible) {
            markerTypes[i].setMap(null);
        } else {
            markerTypes[i].setMap(map);
        }
    }
}

function onDestroy() {
    for (var key in arr) {
        var markerTypes = arr[key];
        if (typeof (markerTypes) == "undefined") {
            continue;
        }
        for (var i = 0; i < markerTypes.length; i++) {
            markerTypes[i].setMap(null);
            markerTypes[i] = null;
        }
    }
    arr = new Array();
    for (var i = 0; i < flightPath.length; i++) {
        flightPath[i].setMap(null);
    }
    marker = null;
    markerPhone = null;
    markerDevice = null;
    flightPath = [];
    cleanTrackPath();
}

function addMarkers(objs, ic, mapType) {
    var markerTypes = [];
    if (objs != null) {

        var img_url = "./img/" + ic + ".png";
        // 创建对象
        var img = new Image();
        // 改变图片的src
        img.src = img_url;

        img.onload = function () {

            if (img.width > 40) {
                img.width = img.width / 2;
                img.height = img.height / 2;
            }
            var phoneImage = {
                url: img_url,
                scaledSize: new google.maps.Size(img.width, img.height)
            };

            for (var i in objs) {
                var obj = objs[i];
                var myNewLatlng;
                if (mapType == "GPS") {
                    var gpsvalue1 = GPS.gcj_encrypt(obj.lat, obj.lng);
                    latlng = new google.maps.LatLng(gpsvalue1.lat, gpsvalue1.lon);
                } else {
                    myNewLatlng = new google.maps.LatLng(obj.lat, obj.lng);
                }

                var marker = new google.maps.Marker({
                    position: myNewLatlng,
                    icon: phoneImage
                });
                //                alert(obj.isVisible);
                if (obj.isVisible) {
                    marker.setMap(map);
                }
                google.maps.event.addListener(marker, 'click', (function (marker, obj) {
                        return function () {
                            // if (typeof marker.isMsg === "function") {
                            //     manualClosure = false;
                            //     marker.setContent(obj.msg);
                            // } else {
                            //     infowindow.setContent(obj.msg);
                            //     infowindowOpen(map, marker);
                            //     infowindow.setPosition(marker.getPosition());
                            // }
                            infowindow.setOptions({pixelOffset: new google.maps.Size(0, 0)});
                            infowindow.setContent(obj.msg);
                            infowindowOpen(map, marker);
                            infowindow.setPosition(marker.getPosition());

                            map.panTo(marker.getPosition());
                            var latlng = marker.getPosition();
                            bridgeInterface.LatlngCallback(latlng.lat(), latlng.lng());
                        }
                    }
                )(marker, obj));
                markerTypes.push(marker);
            }
        }
    }
    return markerTypes;
}

function addMarker(obj, ic) {
    if (obj != null) {
        var markerTypes = [];
        var img_url = "./img/" + ic + ".png";
        // 创建对象
        var img = new Image();
        // 改变图片的src
        img.src = img_url;
        img.onload = function () {
            if (img.width > 40) {
                img.width = img.width / 2;
                img.height = img.height / 2;
            }
            var phoneImage = {
                url: img_url,
                scaledSize: new google.maps.Size(img.width, img.height)
            };
            var myNewLatlng;
            if (mapType == "GPS") {
                var gpsvalue1 = GPS.gcj_encrypt(obj.lat, obj.lng);
                latlng = new google.maps.LatLng(gpsvalue1.lat, gpsvalue1.lon);
            } else {
                myNewLatlng = new google.maps.LatLng(obj.lat, obj.lng);
            }
            var marker = addMarkerRaw(myNewLatlng);
            marker.setPosition(myNewLatlng);
            marker.setIcon(phoneImage);
            if (obj.isVisible) {
                marker.setMap(map);
            } else {
                marker.setMap(null);
            }
            google.maps.event.addListener(marker, 'click', (function (marker, obj) {
                    return function () {
                        // if (typeof marker.isMsg === "function") {
                        //     marker.setContent(obj.msg);
                        //     manualClosure = false;
                        // } else {
                        //     infowindow.setContent(obj.msg);
                        //     infowindowOpen(map, marker);
                        //     infowindow.setPosition(marker.getPosition());
                        // }
                        infowindow.setOptions({pixelOffset: new google.maps.Size(0, 0)});
                        infowindow.setContent(obj.msg);
                        infowindowOpen(map, marker);
                        infowindow.setPosition(marker.getPosition());
                        map.panTo(marker.getPosition());
                        var latlng = marker.getPosition();
                        bridgeInterface.LatlngCallback(latlng.lat(), latlng.lng());
                    }
                }
            )(marker, obj));
            markerTypes.push(marker);
            arr[ic] = markerTypes;
        }
    }
}

//显示实际行车路线
function showpath(startlat1, startlng1, endlat2, endlng2) {
    var pointArr = new google.maps.LatLng(startlat1, startlng1);
    var pointArr1 = new google.maps.LatLng(endlat2, endlng2);
    directionsDisplay = new google.maps.DirectionsRenderer({
        markerOptions: {
            map: map
        }//行车路线
    });
    directionsDisplay.setMap(map);
    var request = {
        origin: pointArr,
        //起点
        destination: pointArr1,
        //终点
        optimizeWaypoints: false,
        //为true，重新排列中间路标顺序，最大程度降低路线整体成本
        travelMode: google.maps.TravelMode.TRANSIT,
        //驾车路线
        unitSystem: google.maps.UnitSystem.METRIC//单位为米
    };
    directionsService.route(request, function (response, status) {
        if (status == google.maps.DirectionsStatus.OK) {
            directionsDisplay.setDirections(response);
            //将返回的路线信息赋给directionsDisplay，显示在地图上
            flightPath.push(response);
        } else {
        }
    });
}

function showStreetView(lat, lng) {
    var latLng = new google.maps.LatLng(lat, lng);
    var panoramaOptions = {
        position: latLng,
        pov: {
            heading: 34,
            pitch: 10,
            zoom: 1
        },
        enableCloseButton: false,
        addressControl: true,
        panControl: true,
        addressControlOptions: {
            position: google.maps.ControlPosition.TOP_RIGHT
        }
    };
    var panorama = new google.maps.StreetViewPanorama(document.getElementById("map-canvas"), panoramaOptions);
    map.setStreetView(panorama);
    var cafeMarker = new google.maps.Marker({
            position: latLng,
            map: panorama,
            icon: "../img_product_type/" + "icon_marka" + ".png"
    });
}

var currentLocationMarker;
var mapCtrl = {

    /*当前位置*/
    currentLocation: function (lat, lng, center, mapType, msg, ic,hangxiang) {
        //		alert("lat="+lat+"\n"+"lnt="+lng);
        if (mapType == "GPS") {
            var gpsvalue1 = GPS.gcj_encrypt(lat, lng);
            lat = gpsvalue1.lat;
            lng = gpsvalue1.lon;
        }
        var icon = "";
        showMyLocDirec = GetQueryString("showMyLocDirec");
        if(showMyLocDirec){
            if (typeof (ic) == "undefined" || ic == null || ic == "") {
                icon="../img_product_type_list/" + "im_navi_gps_locked" + ".png";
            } else {
                icon = ic;
            }
        }else{
            if (typeof (ic) == "undefined" || ic == null || ic == "") {
                icon = "../img_product_type/" + "geo" + ".png";
            } else {
                icon = ic;
            }
        }
//        alert(showMyLocDirec+"   "+icon);
        var rotate=0;
        if (typeof (hangxiang) == "undefined" || hangxiang == null || hangxiang == ""||isNaN(hangxiang)) {
            rotate=0;
        } else {
            rotate = hangxiang;
        }
        setPhoneLocCenter(lat, lng, center, icon, "My location", rotate, function markerLoaded(marker1) {//            onlyInfoPop(marker, "My location");
            currentLocationMarker=marker1;
//            onlyInfoPop(marker1, "My location");
        });

    },

    /*当前位置方向*/
    currentLocationRotate: function (hangxiang) {
        if(currentLocationMarker&&typeof currentLocationMarker.isMsg === "function"){
            currentLocationMarker.setRotate(hangxiang);
        }
    },

    /*报警位置*/
    alarmLoc: function (lat, lng, center, mapType, msg) {
        if (mapType == "GPS") {
            var gpsvalue1 = GPS.gcj_encrypt(lat, lng);
            lat = gpsvalue1.lat;
            lng = gpsvalue1.lon;
        }
        setPhoneLocCenter(lat, lng, center, "../img_product_type/" + "im_alarm_loc" + ".png", msg, 0, function markerLoaded(marker1) {
            onlyInfoPop(marker1, msg);
        });
    },

    /*设备位置*/
    deviceLoc: function (lat, lng, center, mapType, icon, msg, hangxiang,pop) {
        if (mapType == "GPS") {
            var gpsvalue1 = GPS.gcj_encrypt(lat, lng);
            lat = gpsvalue1.lat;
            lng = gpsvalue1.lon;
        }
        setDeviceLocCenter(lat, lng, center, icon, msg, hangxiang, function markerLoaded(marker1) {
            if (typeof (pop) == "undefined" || pop == null || pop == "" || pop!="0") {
                setTimeout(function () {
                    onlyInfoPop(marker1, msg);
                }, 50);
            }
        });

    },

    /*反地理编码*/
    getAddress: function (lat, lng, mapType, responseCallback) {
        if (mapType == "GPS") {
            var gpsvalue1 = GPS.gcj_encrypt(lat, lng);
            lat = gpsvalue1.lat;
            lng = gpsvalue1.lon;
        }
        getAddress(lat, lng, responseCallback);

    },

    /*围栏*/
    addFenceLoc: function (lat, lng, mapType, radiuvalue) {
        if (mapType == "GPS") {
            var gpsvalue1 = GPS.gcj_encrypt(lat, lng);
            lat = gpsvalue1.lat;
            lng = gpsvalue1.lon;
        }
        setFence(1, radiuvalue, lat, lng);

    },

    /*普通，卫星地图切换*/
    satellite: function (flag) {
        satellite(flag)
    },

    /*路况*/
    trafficLayer: function (flag) {
        traffic(flag)
    },

    /*Track*/
    track: function (lat, lng, center, mapType, msg, lineColor) {
        tracklines(lat, lng, center, lineColor)
    },

    /*showStreetView*/
    showStreetView: function (lat, lng, mapType) {
        if (mapType == "GPS") {
            var gpsvalue1 = GPS.gcj_encrypt(lat, lng);
            lat = gpsvalue1.lat;
            lng = gpsvalue1.lon;
        }
        showStreetView(lat, lng)
    },

    /*清除Track*/
    cleanTrack: function () {
        cleanTrackPath()
    },

    /*放大缩小比例*/
    scaleZoom: function (operation) {
        scaleZoom(operation)
    },

    /*多经纬度画线*/
    drawLines: function (latLngs, mapType) {
        drawSymbolLines(latLngs, mapType)
    },

    /*多经纬度画线*/
    drawDistanceLineBetweenTwoPlaces: function (startlat, startlng, endLat, endLng, mapType, color, isBounds) {
        drawDistanceLineBetweenTwoPlaces(startlat, startlng, endLat, endLng, color, isBounds)
    },

    /*多经纬度画线*/
    clearDistanceLineBetweenTwoPlacesOverlayOptions: function () {
        clearDistanceLineBetweenTwoPlacesOverlayOptions()
    },

    /*多经纬度画线*/
    addMarkerTypes: function (stays, lbses, wifis, mapType) {
        addMarkerTypes(stays, lbses, wifis, mapType)
    },

    /*多经纬度画线*/
    addMarkerType: function (markerInfo, markerType, mapType) {
        addMarker(markerInfo, markerType, mapType)
    },

    /*多经纬度画线*/
    addMoreDeviceMarkers: function (moreDevices, mapType, fitBounds, selMacId, firstShowPopInfoWindow) {
        addMoreDeviceMarkers(moreDevices, mapType, fitBounds, selMacId, firstShowPopInfoWindow)
    },

    /*显示隐藏markersType*/
    removeMarkerTypes: function (isVisible, key) {
        if (key == "lbsWifi") {
            removeMarkerTypes(isVisible, "lbs");
            removeMarkerTypes(isVisible, "wifi");
        } else {
            removeMarkerTypes(isVisible, key)
        }

    },

    /*显示隐藏markersType*/
    showSelTheFirstFewDeviceMsg: function (macId, msg,isCenter) {
        showSelTheFirstFewDeviceMsg(macId, msg,isCenter)
    },

    onDestroy: function () {
        onDestroy();
    },

    linePlanning: function (locLat, locLng, lat, lng, center, mapType, msg) {
        if (mapType == "GPS") {
            var gpsvalue1 = GPS.gcj_encrypt(lat, lng);
            lat = gpsvalue1.lat;
            lng = gpsvalue1.lon;
            var locGpsvalue1 = GPS.gcj_encrypt(locLat, locLng);
            locLat = locGpsvalue1.lat;
            locLng = locGpsvalue1.lon;
        }
        //        setPhoneLocCenter(lat,lng,center,"im_alarm_loc",msg,function markerLoaded(marker){
        //            onlyInfoPop(marker,msg);
        //        });
        var locGpsvalue1 = GPS.gcj_encrypt(locLat, locLng);
        locLat = locGpsvalue1.lat;
        locLng = locGpsvalue1.lon;
        //		setPhoneLocCenter(locLat, locLng,center,"geo","My location",function markerLoaded(marker){
        //			onlyInfoPop(marker,"My location");
        //		});
        showpath(locLat, locLng, lat, lng);
    }

}
